# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2008 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import tools
from osv import fields,osv

class res_partner(osv.osv):
    _description='The partner object'
    _inherit = "res.partner"

    _columns = {
        'ape': fields.char('Code APE/NAF', size=5, help=tools.ustr("code de l'Activite Principale Exerce \ncompos des 4 chiffres NACE suivis d'une lettre")),
    }

    def onchange_ape(self, cr, uid, ids, value):
        nace = ''
        if value and len(value) == 5:
            nace = value[:4]
            if nace.isdigit():
                nace = value[:4]
            else :
                nace = ''
        return {'value':{'nace': nace}}

    def write(self, cr, uid, ids, vals, context={}):
        if 'ape' in vals: # nace code has been modified
            if vals['ape']:
                if len(vals['ape']) == 5 and vals['ape'][4].isalpha() and vals['ape'][:4].isdigit(): 
                    ape = ''
                    ape = vals['ape'][:4] + vals['ape'][4].upper()
                    vals['ape'] = ape
                    vals['nace'] = vals['ape'][:4]
                else:
                    raise osv.except_osv("Warning !!","code APE is not correct.\ncode APE has 4 digits and one letter") 
            else :
                vals['nace'] = ''
                    
        return super(res_partner, self).write(cr, uid, ids, vals, context)
res_partner()
