# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2008 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import tools
from osv import fields,osv

class res_partner(osv.osv):
    _description='The partner object'
    _inherit = "res.partner"

    _columns = {
        'siret': fields.char('SIRET', size=14, help=tools.ustr("numéro identifiant les établissements de l'entreprise \nà 14 chiffres (SIREN+NIC)")),
        'siren': fields.char('SIREN', size=9, readonly=True, help=tools.ustr("numéro unique d'identification de l'entreprise \nà 9 chiffres")),
        'rcs': fields.char('RCS', size=128, help=tools.ustr("code du registre du commerce \nRCS, RM, RSEIRL")),
    }

    def onchange_siret(self, cr, uid, ids, value):
        siren=''
        if value and value.isdigit():
            if len(value) >= 9:
                siren = value[:9]
        return {'value':{'siren': siren}}

    def write(self, cr, uid, ids, vals, context={}):
        if 'siret' in vals: # le numéro siret a été modifié
            if vals['siret']:
                if vals['siret'].isdigit() and len(vals['siret']) == 14:
                     vals['siren'] = vals['siret'][:9]
                else:
                    raise osv.except_osv("Attention !!","Le nombre de chiffre du numéro de SIRET est incorrect.\nUn numéro SIRET contient 14 chiffres.")
            else:
               vals['siren'] = "" 
        return super(res_partner, self).write(cr, uid, ids, vals, context)
res_partner()
